/*==============================================================================
Fractal XDoclet Plugin - Copyright (C) 2002-2006 INRIA Futurs / LIFL
Fractal Component Model (contact: fractal@objectweb.org)

This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the Free 
Software Foundation; either version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

Initial developer(s): Romain Rouvoy (romain.rouvoy@lifl.fr)
Contributor(s): .
--------------------------------------------------------------------------------
$Id: Request.java,v 1.2 2006/08/30 15:18:21 rouvoy Exp $
==============================================================================*/
package comanche;

import java.io.PrintStream;
import java.io.Reader;
import java.net.Socket;

/**
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 * @version $Revision: 1.2 $
 * @data
 */
public class Request {
    
    /** The socket used to send reply. */
    public Socket s;

    /** The data reader. */
    public Reader in;

    /** The print stream used to reply. */
    public PrintStream out;

    /** The url of the request. */
    public String url;

    /**
     * Constructor.
     * @param s the socket used to reply.
     */
    public Request(Socket s) {
        this.s = s;
    }
}
